using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	class ColliderDebug : MonoBehaviour
    {
        void Update()
        {
            foreach (Collider2D coller in gameObject.GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coller); //Instance.AddComponent<ColliderDebug>(); (add this to instances)
            }
        }
    }
    public class Mod
    {
        public static void Main()
        {				
		   CategoryBuilder.Create("Karabah", "Adds Azerbaijan and Armenian soldiers.", ModAPI.LoadSprite("category icon.png"));
		    //READ README.TXT


			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah]armenian patch",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Identification",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/armenia.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/armenia.png", 6f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            ); 

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah]Azerbaijan flag patch",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Identification",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/patc.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/gr_p.png", 6f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            ); 
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Azerbaijan soldier", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/azer.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/azer1.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Azerbaijan soldier (green shirt)", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/azer.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/azer2.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Azerbaijan soldier (green uniform)", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/azer.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/azer3.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Azerbaijan soldier (green uniform with TTSKO shirt)", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/azer.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/azer4.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Armenian soldier", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/arme.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/arme.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Armenian soldier (afghanka pants)", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/arme.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/arme2.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] Armenian soldier (afghanka shirt)", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "balls!!!", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/arme.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/arme3.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] misc soldier 1", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/misc.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/ballsss.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] misc soldier 2", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/misc.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/nitz.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] misc soldier 3", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/misc.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/nutz.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[Karabah] misc soldier 4", //name
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side", //description
                    CategoryOverride = ModAPI.FindCategory("Karabah"), //Category
                    ThumbnailOverride = ModAPI.LoadSprite("icons/misc.png"),
                    AfterSpawn = (Instance) =>
                    {	
                        var skin = ModAPI.LoadTexture("94/rolled.png"); //file
	                    var flesh = ModAPI.LoadTexture("6f_flesh.png"); //flesh
	                    var bone = ModAPI.LoadTexture("6f_bone.png"); //bone
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 6f); //number is pixel scale
                    }
                }
            );
		       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah] panamaka",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/panama.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/panama.png", 6f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
		       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah] panamaka (with a star)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "could be used by either side",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/panama.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/panama2.png", 6f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
		       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah] vdv beret",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "afghan afghan afghan",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beret.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/vdvb.png", 6f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
		       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah] afghanka in azerbaijan camo",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "afghan afghan afghan",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cappin.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/afghanka_cap_az.png", 6f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
		       ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "[Karabah] afghanka in armenian camo",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "afghan afghan afghan",
                    CategoryOverride = ModAPI.FindCategory("Karabah"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cappin.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("94/afghanka_cap_ar.png", 6f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
        } 
    }
}